def fact(number: Int) = {
  @scala.annotation.tailrec
  def factRecur(factorial: BigInt, number: Int) : BigInt = {
    if (number == 1)
      factorial
    else
      factRecur(number * factorial, number - 1)
  }
  
  factRecur(BigInt(1), number)
}

println("Factorial of 5 is " + fact(5))
println("Factorial of 10000 is " + fact(10000))
